diff --git a/src/BRepExtrema/BRepExtrema_DistanceSS.cxx b/src/BRepExtrema/BRepExtrema_DistanceSS.cxx
index 877f91d..f43cdd5 100644
--- a/src/BRepExtrema/BRepExtrema_DistanceSS.cxx
+++ b/src/BRepExtrema/BRepExtrema_DistanceSS.cxx
@@ -791,7 +791,6 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Vertex& S1, const TopoDS_Face&
         gp_Pnt Pt,P1=BRep_Tool::Pnt(S1);
         BRepClass_FaceClassifier classifier;
         BRepAdaptor_Surface anAS(S2, Standard_False);
-        const Standard_Real aTol = BRep_Tool::Tolerance(S2);
  
         for (i = 1; i <= NbExtrema; i++)
         {
@@ -803,7 +802,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Vertex& S1, const TopoDS_Face&
               // Check if the parameter does not correspond to a vertex
               Ext.Parameter(i,U,V);
               const gp_Pnt2d PUV(U,V);
-              classifier.Perform(S2, PUV, aTol);
+              classifier.Perform(S2, PUV);
               if (classifier.State()==TopAbs_IN)
               {
                 if (myDstRef > Dstmin)
@@ -847,8 +846,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Vertex&
         Standard_Real U,V;
         gp_Pnt Pt,P2=BRep_Tool::Pnt(S2);
         BRepClass_FaceClassifier classifier;
-        const Standard_Real aTol = BRep_Tool::Tolerance(S1);
- 
+
         for (i = 1; i <= NbExtrema; i++)
         {
           if (fabs(Dstmin-sqrt(Ext.SquareDistance(i)))<myEps)
@@ -859,7 +857,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Vertex&
               // Check if the parameter does not correspond to a vertex
               Ext.Parameter(i,U,V);
               const gp_Pnt2d PUV(U,V);
-              classifier.Perform(S1, PUV, aTol);
+              classifier.Perform(S1, PUV);
               if (classifier.State()==TopAbs_IN)
               {
                 if (myDstRef > Dstmin)
@@ -992,7 +990,6 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Edge& S1, const TopoDS_Face& S
       {
         Standard_Real Udeb,Ufin,U,V;
         BRep_Tool::Range(S1,Udeb,Ufin);
-        const Standard_Real aTol = BRep_Tool::Tolerance(S2);
         gp_Pnt Pt1,Pt2;
         const Standard_Real epsP=Precision::PConfusion();
 
@@ -1010,7 +1007,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Edge& S1, const TopoDS_Face& S
               {
                 Ext.ParameterOnFace(i,U,V);
                 const gp_Pnt2d PUV(U,V);
-                classifier.Perform(S2, PUV, aTol);
+                classifier.Perform(S2, PUV);
                 if (classifier.State()==TopAbs_IN)
                 {
                   if (myDstRef > Dstmin)
@@ -1043,7 +1040,6 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Edge& S1, const TopoDS_Face& S
 
       gp_Pnt Pt;
       Standard_Real U,V;
-      const Standard_Real aTol = BRep_Tool::Tolerance(S2);
       Standard_Integer i;
       for (i = 1; i <= arrInter.Length(); i++)
       {
@@ -1075,7 +1071,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Edge& S1, const TopoDS_Face& S
                 // Check if the parameter does not correspond to a vertex
                 ExtPF.Parameter(ii,U,V);
                 const gp_Pnt2d PUV(U,V);
-                classifier.Perform(S2, PUV, aTol);
+                classifier.Perform(S2, PUV);
                 if (classifier.State()==TopAbs_IN)
                 {
                   if (myDstRef > Dstmin)
@@ -1135,7 +1131,6 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Edge& S
       {
         Standard_Real Udeb,Ufin,U,V;
         BRep_Tool::Range(S2,Udeb,Ufin);
-        const Standard_Real aTol = BRep_Tool::Tolerance(S1);
         gp_Pnt Pt1,Pt2;
         const Standard_Real epsP=Precision::PConfusion();
 
@@ -1153,7 +1148,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Edge& S
               {
                 Ext.ParameterOnFace(i,U,V);
                 const gp_Pnt2d PUV(U,V);
-                classifier.Perform(S1, PUV, aTol);
+                classifier.Perform(S1, PUV);
                 if (classifier.State()==TopAbs_IN)
                 {
                   if (myDstRef > Dstmin)
@@ -1186,7 +1181,6 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Edge& S
 
       gp_Pnt Pt;
       Standard_Real U,V;
-      const Standard_Real aTol = BRep_Tool::Tolerance(S1);
       Standard_Integer i;
       for (i = 1; i <= arrInter.Length(); i++)
       {
@@ -1218,7 +1212,7 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Edge& S
                 // Check if the parameter does not correspond to a vertex
                 ExtPF.Parameter(ii,U,V);
                 const gp_Pnt2d PUV(U,V);
-                classifier.Perform(S1, PUV, aTol);
+                classifier.Perform(S1, PUV);
                 if (classifier.State()==TopAbs_IN)
                 {
                   if (myDstRef > Dstmin)
@@ -1273,9 +1267,6 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Face& S
       Dstmin = sqrt(Dstmin);
       if ((Dstmin < myDstRef - myEps) || (fabs(Dstmin-myDstRef) < myEps))
       {
-        const Standard_Real aTol1=BRep_Tool::Tolerance(S1);
-        const Standard_Real aTol2=BRep_Tool::Tolerance(S2);
-
         gp_Pnt Pt1,Pt2;
         gp_Pnt2d PUV;
         Standard_Real U1,V1,U2,V2;
@@ -1292,12 +1283,12 @@ void BRepExtrema_DistanceSS::Perform(const TopoDS_Face& S1, const TopoDS_Face& S
               // Check if the parameter does not correspond to a vertex
               Ext.ParameterOnFace1(i,U1,V1);
               PUV.SetCoord(U1,V1);
-              classifier.Perform(S1, PUV, aTol1);
+              classifier.Perform(S1, PUV);
               if (classifier.State()==TopAbs_IN)
               {
                 Ext.ParameterOnFace2(i,U2,V2);
                 PUV.SetCoord(U2,V2);
-                classifier.Perform(S2, PUV, aTol2);
+                classifier.Perform(S2, PUV);
                 if (classifier.State()==TopAbs_IN)
                 {
                   if (myDstRef > Dstmin)
diff --git a/src/BRepExtrema/BRepExtrema_ExtCF.cxx b/src/BRepExtrema/BRepExtrema_ExtCF.cxx
index 22fecc8..d05c84e 100644
--- a/src/BRepExtrema/BRepExtrema_ExtCF.cxx
+++ b/src/BRepExtrema/BRepExtrema_ExtCF.cxx
@@ -95,7 +95,6 @@ void BRepExtrema_ExtCF::Perform(const TopoDS_Edge& E, const TopoDS_Face& F2)
   {
     // Exploration of points and classification
     BRepClass_FaceClassifier classifier;
-    const Standard_Real aTol = BRep_Tool::Tolerance(F2);
     Extrema_POnCurv P1;
     Extrema_POnSurf P2;
 
@@ -104,7 +103,7 @@ void BRepExtrema_ExtCF::Perform(const TopoDS_Edge& E, const TopoDS_Face& F2)
       myExtCS.Points(i, P1, P2);
       P2.Parameter(U1, U2);
       const gp_Pnt2d Puv(U1, U2);
-      classifier.Perform(F2, Puv, aTol);
+      classifier.Perform(F2, Puv);
       const TopAbs_State state = classifier.State();
       if (state == TopAbs_ON || state == TopAbs_IN)
       {
diff --git a/src/BRepExtrema/BRepExtrema_ExtFF.cxx b/src/BRepExtrema/BRepExtrema_ExtFF.cxx
index 252f744..a795ad8 100644
--- a/src/BRepExtrema/BRepExtrema_ExtFF.cxx
+++ b/src/BRepExtrema/BRepExtrema_ExtFF.cxx
@@ -76,8 +76,7 @@ void BRepExtrema_ExtFF::Perform(const TopoDS_Face& F1, const TopoDS_Face& F2)
     return; // protect against non-geometric type (e.g. triangulation)
 
   Handle(BRepAdaptor_HSurface) HS1 = new BRepAdaptor_HSurface(Surf1);
-  const Standard_Real aTol1 = BRep_Tool::Tolerance(F1),
-                      aTol2 = BRep_Tool::Tolerance(F2);
+  const Standard_Real aTol1 = BRep_Tool::Tolerance(F1);
   Standard_Real U1, U2, V1, V2;
   BRepTools::UVBounds(F1, U1, U2, V1, V2);
   myExtSS.Perform(HS1->Surface(), U1, U2, V1, V2, Max(Min(Surf1.UResolution(aTol1),
@@ -101,13 +100,13 @@ void BRepExtrema_ExtFF::Perform(const TopoDS_Face& F1, const TopoDS_Face& F2)
       myExtSS.Points(i, P1, P2);
       P1.Parameter(U1, U2);
       const gp_Pnt2d Puv1(U1, U2);
-      classifier.Perform(F1, Puv1, aTol1);
+      classifier.Perform(F1, Puv1);
       const TopAbs_State state1 = classifier.State();
       if (state1 == TopAbs_ON || state1 == TopAbs_IN)
       {
         P2.Parameter(U1, U2);
         const gp_Pnt2d Puv2(U1, U2);
-        classifier.Perform(F2, Puv2, aTol2);
+        classifier.Perform(F2, Puv2);
         const TopAbs_State state2 = classifier.State();
         if (state2 == TopAbs_ON || state2 == TopAbs_IN)
         {
diff --git a/src/BRepExtrema/BRepExtrema_ExtPF.cxx b/src/BRepExtrema/BRepExtrema_ExtPF.cxx
index de93cb0..22bd820 100644
--- a/src/BRepExtrema/BRepExtrema_ExtPF.cxx
+++ b/src/BRepExtrema/BRepExtrema_ExtPF.cxx
@@ -86,12 +86,11 @@ void BRepExtrema_ExtPF::Perform(const TopoDS_Vertex& TheVertex, const TopoDS_Fac
     BRepClass_FaceClassifier classifier;
     Standard_Real U1, U2;
     BRepAdaptor_Surface anAS(TheFace, Standard_False);
-    const Standard_Real aTol = BRep_Tool::Tolerance(TheFace);
     for (Standard_Integer i = 1; i <= myExtPS.NbExt(); i++)
     {
       myExtPS.Point(i).Parameter(U1, U2);
       const gp_Pnt2d Puv(U1, U2);
-      classifier.Perform(TheFace, Puv, aTol);
+      classifier.Perform(TheFace, Puv);
       const TopAbs_State state = classifier.State();
       if(state == TopAbs_ON || state == TopAbs_IN)
       {
diff --git a/src/BRepFeat/BRepFeat.cxx b/src/BRepFeat/BRepFeat.cxx
index 09e7ec8..65a024c 100644
--- a/src/BRepFeat/BRepFeat.cxx
+++ b/src/BRepFeat/BRepFeat.cxx
@@ -452,7 +452,7 @@ Standard_Boolean BRepFeat::IsInside(const TopoDS_Face& F1,
     vperiod = S->VPeriod();
   }
   TopoDS_Shape aLocalShape = F2.Oriented(TopAbs_FORWARD);
-  BRepTopAdaptor_FClass2d FC (TopoDS::Face(aLocalShape),Precision::Confusion());
+  BRepTopAdaptor_FClass2d FC (TopoDS::Face(aLocalShape));
 //  BRepTopAdaptor_FClass2d FC (TopoDS::Face(F2.Oriented(TopAbs_FORWARD)),
 //                                Precision::Confusion());
   for(; exp.More(); exp.Next()) {
diff --git a/src/BRepFeat/BRepFeat_MakeRevolutionForm.cxx b/src/BRepFeat/BRepFeat_MakeRevolutionForm.cxx
index 83bb715..750179c 100644
--- a/src/BRepFeat/BRepFeat_MakeRevolutionForm.cxx
+++ b/src/BRepFeat/BRepFeat_MakeRevolutionForm.cxx
@@ -876,7 +876,7 @@ void BRepFeat_MakeRevolutionForm::Init(const TopoDS_Shape& Sbase,
     BRepLib_MakeFace newbndface(myPln->Pln(), Wiwiwi, Standard_True);
     TopoDS_Face NewBndFace = TopoDS::Face(newbndface.Shape());
 
-    BRepTopAdaptor_FClass2d Cl(NewBndFace, Precision::Confusion());
+    BRepTopAdaptor_FClass2d Cl(NewBndFace);
     Standard_Real paru, parv;
     ElSLib::Parameters(myPln->Pln(), CheckPnt, paru, parv);
     gp_Pnt2d checkpnt2d(paru, parv);
diff --git a/src/BRepFeat/BRepFeat_RibSlot.cxx b/src/BRepFeat/BRepFeat_RibSlot.cxx
index 7172bef..ce35431 100644
--- a/src/BRepFeat/BRepFeat_RibSlot.cxx
+++ b/src/BRepFeat/BRepFeat_RibSlot.cxx
@@ -1519,8 +1519,7 @@ Standard_Boolean BRepFeat_RibSlot::SlidingProfile(TopoDS_Face& Prof,
 // CheckPnt : point slightly inside the material side
 // Bndface  : face/cut of the bounding box in the plane of the profile
     
-    const Standard_Real aTolF = BRep_Tool::Tolerance(fac);
-    BRepTopAdaptor_FClass2d Cl(fac, aTolF);
+    BRepTopAdaptor_FClass2d Cl(fac);
     Standard_Real u, v;
     ElSLib::Parameters(myPln->Pln(), CheckPnt, u, v);
     gp_Pnt2d checkpnt2d(u, v);
@@ -2207,8 +2206,7 @@ Standard_Boolean BRepFeat_RibSlot::NoSlidingProfile(TopoDS_Face& Prof,
   
 //    if(!Concavite) {
   if(Concavite == 3) {
-    const Standard_Real aTolF = BRep_Tool::Tolerance(fac);
-    BRepTopAdaptor_FClass2d Cl(fac, aTolF);
+    BRepTopAdaptor_FClass2d Cl(fac);
     Standard_Real u, v;
     ElSLib::Parameters(myPln->Pln(), CheckPnt, u, v);
     gp_Pnt2d checkpnt2d(u, v);
diff --git a/src/BRepLib/BRepLib.cxx b/src/BRepLib/BRepLib.cxx
index 7ac087c..78e428f 100644
--- a/src/BRepLib/BRepLib.cxx
+++ b/src/BRepLib/BRepLib.cxx
@@ -444,26 +444,30 @@ Standard_Boolean  BRepLib::BuildCurve3d(const TopoDS_Edge& AnEdge,
       Handle(Geom_Curve) NewCurvePtr ;
 
       GeomLib::BuildCurve3d(Tolerance,
-        CurveOnSurface,
-        f,
-        l,
-        NewCurvePtr,
-        max_deviation,
-        average_deviation,
-        Continuity,
-        MaxDegree,
-        evaluateMaxSegment(MaxSegment,CurveOnSurface)) ;
-      BRep_Builder B;	
-      tolerance = BRep_Tool::Tolerance(AnEdge) ;
+                            CurveOnSurface,
+                            f,
+                            l,
+                            NewCurvePtr,
+                            max_deviation,
+                            average_deviation,
+                            Continuity,
+                            MaxDegree,
+                            evaluateMaxSegment(MaxSegment, CurveOnSurface));
+      BRep_Builder B;
+      tolerance = BRep_Tool::Tolerance(AnEdge);
       //Patch
       //max_deviation = Max(tolerance, max_deviation) ;
-      max_deviation = Max( tolerance, Tolerance );
+      max_deviation = Max(tolerance, Tolerance);
       if (NewCurvePtr.IsNull())
         return Standard_False;
+
       B.UpdateEdge(TopoDS::Edge(AnEdge),
-        NewCurvePtr,
-        L[0],
-        max_deviation) ;
+                   NewCurvePtr,
+                   L[0],
+                   max_deviation);
+
+      SameParameter(AnEdge, max_deviation, Standard_True);
+
       if (jj == 1 ) {
         //
         // if there is only one curve on surface attached to the edge
diff --git a/src/BRepLib/BRepLib_FindSurface.cxx b/src/BRepLib/BRepLib_FindSurface.cxx
index 965d008..3daac04 100644
--- a/src/BRepLib/BRepLib_FindSurface.cxx
+++ b/src/BRepLib/BRepLib_FindSurface.cxx
@@ -565,7 +565,7 @@ void BRepLib_FindSurface::Init(const TopoDS_Shape&    S,
       TopoDS_Face aTmpFace = BRepLib_MakeFace(mySurface, Precision::Confusion());
       BRep_Builder BB;
       BB.Add(aTmpFace, aW);
-      BRepTopAdaptor_FClass2d FClass(aTmpFace, gp::Resolution());
+      BRepTopAdaptor_FClass2d FClass(aTmpFace);
       if ( FClass.PerformInfinitePoint() == TopAbs_IN ) 
       {
         gp_Dir aN = aPlane->Position().Direction();
diff --git a/src/BRepLib/BRepLib_MakeFace.cxx b/src/BRepLib/BRepLib_MakeFace.cxx
index 90336af..6165abc 100644
--- a/src/BRepLib/BRepLib_MakeFace.cxx
+++ b/src/BRepLib/BRepLib_MakeFace.cxx
@@ -849,7 +849,7 @@ void BRepLib_MakeFace::CheckInside()
 {
   // compute the area and return the face if the area is negative
   TopoDS_Face F = TopoDS::Face(myShape);
-  BRepTopAdaptor_FClass2d FClass(F,gp::Resolution());
+  BRepTopAdaptor_FClass2d FClass(F);
   if ( FClass.PerformInfinitePoint() == TopAbs_IN) {
     BRep_Builder B;
     TopoDS_Shape S = myShape.EmptyCopied();
diff --git a/src/BRepOffset/BRepOffset_MakeOffset.cxx b/src/BRepOffset/BRepOffset_MakeOffset.cxx
index 1ded0aa..db81633 100644
--- a/src/BRepOffset/BRepOffset_MakeOffset.cxx
+++ b/src/BRepOffset/BRepOffset_MakeOffset.cxx
@@ -2678,7 +2678,7 @@ void BRepOffset_MakeOffset::MakeMissingWalls ()
                 TopoDS_Face aFace;
                 BB.MakeFace(aFace, aPL, Precision::Confusion());
                 BB.Add (aFace, aW);
-                aClsf.Init(aFace, Precision::Confusion());
+                aClsf.Init(aFace);
                 bIsHole=aClsf.IsHole();
                 if ((bIsHole && !i) || (!bIsHole && i)) {
                   aW.Nullify();
diff --git a/src/BRepOffset/BRepOffset_Tool.cxx b/src/BRepOffset/BRepOffset_Tool.cxx
index ff88c98..3606850 100644
--- a/src/BRepOffset/BRepOffset_Tool.cxx
+++ b/src/BRepOffset/BRepOffset_Tool.cxx
@@ -4026,8 +4026,7 @@ void BRepOffset_Tool::CorrectOrientation(const TopoDS_Shape&        SI,
       }
       if (YaInt) {
         TopoDS_Shape aLocalFace = FI.Oriented(TopAbs_FORWARD);
-        BRepTopAdaptor_FClass2d FC (TopoDS::Face(aLocalFace),
-                                    Precision::Confusion());
+        BRepTopAdaptor_FClass2d FC (TopoDS::Face(aLocalFace));
 	for (itE.Initialize(LOE); itE.More(); itE.Next()) {
 	  TopoDS_Shape&   OE   = itE.Value();
 	  if (NewEdges.Contains(OE)) {
diff --git a/src/BRepOffsetAPI/BRepOffsetAPI_MakeOffset.cxx b/src/BRepOffsetAPI/BRepOffsetAPI_MakeOffset.cxx
index 419912e..79f578e 100644
--- a/src/BRepOffsetAPI/BRepOffsetAPI_MakeOffset.cxx
+++ b/src/BRepOffsetAPI/BRepOffsetAPI_MakeOffset.cxx
@@ -234,7 +234,7 @@ static void BuildDomains(TopoDS_Face&               myFace,
     BRepAdaptor_Surface   S(F,0);
     Standard_Real         Tol = BRep_Tool::Tolerance(F); 
 
-    BRepTopAdaptor_FClass2d CL(F,Precision::Confusion());
+    BRepTopAdaptor_FClass2d CL(F);
 
     TopTools_ListIteratorOfListOfShape itW(LOW);
     while (itW.More()) {
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx
index decc3b4..fb9fc3d 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx
@@ -127,8 +127,7 @@ private:
 //function : Default constructor
 //purpose  : 
 //=======================================================================
-BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d() : myTol3D(Precision::Confusion()),
-                                                     myUmin(RealLast()),
+BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d() : myUmin(RealLast()),
                                                      myVmin(RealLast()),
                                                      myUmax(-myUmin),
                                                      myVmax(-myVmin)
@@ -139,14 +138,12 @@ BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d() : myTol3D(Precision::Confusio
 //function : Constructor
 //purpose  : 
 //=======================================================================
-BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d(const TopoDS_Face& theFace,
-                                                 const Standard_Real theTol3D):
+BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d(const TopoDS_Face& theFace):
                                                  myFace(theFace),
-                                                 myTol3D(theTol3D),
                                                  myUmin(RealLast()), myVmin(RealLast()),
                                                  myUmax(-myUmin), myVmax(-myVmin)
 {
-  Init(myFace, theTol3D);
+  Init(myFace);
 }
 
 //=======================================================================
@@ -176,8 +173,7 @@ static Standard_Boolean ComputeDeviation(const gp_Pnt2d& thePf,
 //function : Init
 //purpose  : 
 //=======================================================================
-void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
-                                   const Standard_Real theTol3D)
+void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace)
 {
   Standard_Boolean WireIsEmpty, Ancienpnt3dinitialise, degenerated;
   Standard_Integer nbpnts, firstpoint, NbEdges;
@@ -205,9 +201,6 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
   //
   myFace = theFace;
   myFace.Orientation(TopAbs_FORWARD);
-  myTol3D = theTol3D;
-  const Standard_Real aTolU = anAS.UResolution(theTol3D),
-                      aTolV = anAS.VResolution(theTol3D);
   //const Standard_Real aMaxGapU = Max(aTolU, Precision::PConfusion());
   //const Standard_Real aMaxGapV = Max(aTolV, Precision::PConfusion());
   //
@@ -226,8 +219,6 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
     //
     nbpnts = 0;
     firstpoint = 1;
-    FlecheU = aTolU;
-    FlecheV = aTolV;
     WireIsEmpty = Standard_True;
     Ancienpnt3dinitialise = Standard_False;
     Ancienpnt3d.SetCoord(0., 0., 0.);
@@ -237,6 +228,7 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
     // NbEdges
     NbEdges = 0;
     aExp.Init(aW, TopAbs_EDGE);
+    FlecheU = FlecheV = 0.0;
     for (; aExp.More(); aExp.Next())
     {
       const TopoDS_Edge& anE = TopoDS::Edge(aExp.Current());
@@ -256,6 +248,7 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
     for (; aWExp.More(); aWExp.Next()) {
       NbEdges--;
       edge = aWExp.Current();
+
       Or = edge.Orientation();
       if (!(Or == TopAbs_FORWARD || Or == TopAbs_REVERSED)) {
         continue;
@@ -333,14 +326,14 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
       nbs = Geom2dInt_Geom2dCurveTool::NbSamples(C);
       if (nbs > 2) {
         nbs *= 4;
-      }
+        }
       du = (plbid - pfbid) / (Standard_Real)(nbs - 1);
       //
       if (Or == TopAbs_FORWARD) {
         u = pfbid;
         uFirst = pfbid;
         uLast = plbid;
-      }
+        }
       else {
         u = plbid;
         uFirst = plbid;
@@ -357,7 +350,7 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
         aPrms(1) = uFirst;
         aPrms(2) = uFirst + aCoef*(uLast - uFirst);
         aPrms(3) = uLast;
-      }
+          }
       else if (nbs>2) {
         aNbs1 = nbs;
         aPrms(1) = uFirst;
@@ -382,10 +375,10 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
         //
         u = aPrms(iX);
         P2d = C.Value(u);
-        if(P2d.X()<myUmin) myUmin = P2d.X();
-        if(P2d.X()>myUmax) myUmax = P2d.X();
-        if(P2d.Y()<myVmin) myVmin = P2d.Y();
-        if(P2d.Y()>myVmax) myVmax = P2d.Y();
+        if (P2d.X() < myUmin) myUmin = P2d.X();
+        if (P2d.X() > myUmax) myUmax = P2d.X();
+        if (P2d.Y() < myVmin) myVmin = P2d.Y();
+        if (P2d.Y() > myVmax) myVmax = P2d.Y();
         //
         aDstX = RealLast();
         if (degenerated == Standard_False) {
@@ -532,7 +525,7 @@ void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
 #endif
 
         {
-          const Standard_Real aToler = Max(myTol3D, Precision::Confusion());
+          const Standard_Real aToler = Precision::Confusion();
           if (Abs(anArea) < aToler*aToler)
           {
             // anArea = |A|*|B|*sin(Angle) < Tol*Tol
@@ -895,7 +888,7 @@ TopAbs_State
     //compute state of the point using face classifier
     if(hasToUseClassifier)
     {
-      myClassifier.Perform(myFace, aPuv, myTol3D);
+      myClassifier.Perform(myFace, aPuv);
       aStatus = myClassifier.State();
     }
 
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx
index a7a240a..d5f69b6 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx
@@ -38,13 +38,11 @@ public:
   //! Empty constructor
   Standard_EXPORT BRepTopAdaptor_FClass2d();
 
-  //! Constructs algorithm by theFace and the 3D-tolerance <theTol3D>
-  Standard_EXPORT BRepTopAdaptor_FClass2d(const TopoDS_Face& theFace,
-                                          const Standard_Real theTol3D);
+  //! Constructs algorithm by theFace
+  Standard_EXPORT BRepTopAdaptor_FClass2d(const TopoDS_Face& theFace);
   
-  //! Initializes algorithm by theFace and the 3D-tolerance <theTol3D>
-  Standard_EXPORT void Init(const TopoDS_Face& theFace,
-                            const Standard_Real theTol3D);
+  //! Initializes algorithm by theFace
+  Standard_EXPORT void Init(const TopoDS_Face& theFace);
 
   //! Classifies an infinite 2d point relatively of the Face.
   Standard_EXPORT TopAbs_State PerformInfinitePoint() const;
@@ -90,7 +88,6 @@ private:
   NCollection_Sequence<CSLib_Class2d*> myTabClass;
   NCollection_Sequence<Standard_Integer> myTabOrien;
   TopoDS_Face myFace;
-  Standard_Real myTol3D;
   Standard_Real myUmin;
   Standard_Real myVmin;
   Standard_Real myUmax;
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx
index 121bcb2..1a5a6b0 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx
@@ -189,13 +189,13 @@ static
 //purpose  : 
 //=======================================================================
 TopAbs_State BRepTopAdaptor_TopolTool::Classify(const gp_Pnt2d& P,
-                                                const Standard_Real theTol3D,
+                                                const Standard_Real /*theTol3D*/,
                                                 const Standard_Boolean theIsReqToAdjust)
 {
   if(myFace.IsNull())
     return TopAbs_UNKNOWN;
   if(myFClass2d == NULL) { 
-    myFClass2d = new BRepTopAdaptor_FClass2d(myFace, theTol3D);
+    myFClass2d = new BRepTopAdaptor_FClass2d(myFace);
   } 
 
   const TopAbs_State aState = (myFClass2d->Perform(P,theIsReqToAdjust));
@@ -212,7 +212,7 @@ Standard_Boolean
                                            const Standard_Boolean theIsReqToAdjust)
 {
   if(myFClass2d == NULL) { 
-    myFClass2d = new BRepTopAdaptor_FClass2d(myFace, theTol3D);
+    myFClass2d = new BRepTopAdaptor_FClass2d(myFace);
   } 
   return(TopAbs_ON == myFClass2d->TestOnRestriction(P, theTol3D, theIsReqToAdjust));
 }
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx
index 592295c..8e897c9 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx
@@ -80,7 +80,8 @@ public:
   Standard_EXPORT virtual void NextVertex() Standard_OVERRIDE;
   
   //! Classifies theP2d relatively to the domain of myS.
-  //! theTol3D is the 3D-tolerance (is used for check ON-status).
+  //! theTol3D is not used in this method
+  //! (is entered for compatibility with parent class)
   //! If theIsReqToAdjust == TRUE then the coordinates of theP2d
   //! will be inscribed (if it is possible) in the UV-bounds of myFace.
   Standard_EXPORT virtual
diff --git a/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx b/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx
index 007a5d6..45b474f 100644
--- a/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx
+++ b/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx
@@ -117,7 +117,7 @@ static Standard_Boolean FindPointOnFace(const TopoDS_Face& face, gp_Pnt2d& pt2d)
 
   // verify that (upar vpar) is a point on the face
 
-  BRepClass_FaceClassifier fClass(face, pt2d, gp::Resolution());
+  BRepClass_FaceClassifier fClass(face, pt2d);
 
   if ((fClass.State() == TopAbs_OUT) || (fClass.State() == TopAbs_UNKNOWN)) {
     // try to find a point on face
diff --git a/src/GeomliteTest/GeomliteTest_API2dCommands.cxx b/src/GeomliteTest/GeomliteTest_API2dCommands.cxx
index 89e5f30..619f285 100644
--- a/src/GeomliteTest/GeomliteTest_API2dCommands.cxx
+++ b/src/GeomliteTest/GeomliteTest_API2dCommands.cxx
@@ -301,14 +301,14 @@ static Standard_Integer extrema(Draw_Interpretor& di, Standard_Integer n, const
 //=======================================================================
 static Standard_Integer intersect(Draw_Interpretor& di, Standard_Integer n, const char** a)
 {
-  if (n < 2)
+  if( n < 2) 
   {
     di.PrintHelp(a[0]);
     return 1;
   }
 
   Handle(Geom2d_Curve) C1 = DrawTrSurf::GetCurve2d(a[1]);
-  if (C1.IsNull())
+  if ( C1.IsNull()) 
   {
     di << "Curve " << a[1] << " is null\n";
     return 1;
@@ -332,19 +332,19 @@ static Standard_Integer intersect(Draw_Interpretor& di, Standard_Integer n, cons
     else
     {
       C2 = DrawTrSurf::GetCurve2d(a[i]);
-      if (C2.IsNull())
+    if ( C2.IsNull())
       {
         di << "Curve " << a[i] << " is null\n";
-        return 1;
-      }
+      return 1;
+  }
     }
   }
 
   Geom2dAPI_InterCurveCurve Intersector;
 
-  if (!C2.IsNull())
+  if(!C2.IsNull())
     // Curves intersection
-    Intersector.Init(C1, C2, Tol);
+    Intersector.Init(C1,C2,Tol);
   else
     // Self-intersection of the curve
     Intersector.Init(C1, Tol);
@@ -364,7 +364,7 @@ static Standard_Integer intersect(Draw_Interpretor& di, Standard_Integer n, cons
   {
     // API simplified result
     gp_Pnt2d P = Intersector.Point(i);
-    di << "Intersection point " << i << " : " << P.X() << " " << P.Y() << "\n";
+    di<<"Intersection point "<<i<<" : "<<P.X()<<" "<<P.Y()<<"\n";
     // Intersection extended results from intersection tool
     const IntRes2d_IntersectionPoint& aPInt = anIntTool.Point(i);
     di << "parameter on the fist: " << aPInt.ParamOnFirst();
@@ -374,20 +374,28 @@ static Standard_Integer intersect(Draw_Interpretor& di, Standard_Integer n, cons
       di << "Intersection type: " <<
         (aPInt.TransitionOfFirst().IsTangent() ? "TOUCH" : "INTERSECTION") << "\n";
     }
-    Handle(Draw_Marker2D) mark = new Draw_Marker2D(P, Draw_X, Draw_vert);
+    Handle(Draw_Marker2D) mark = new Draw_Marker2D( P, Draw_X, Draw_vert); 
     dout << mark;
   }
   dout.Flush();
 
-  Handle(Geom2d_Curve) S1, S2;
+  char aBuff[100];
+  Handle(Geom2d_Curve) S1,S2;
   Handle(DrawTrSurf_Curve2d) CD;
   Standard_Integer aNbSegments = Intersector.NbSegments();
   for (Standard_Integer i = 1; i <= aNbSegments; i++)
   {
     di << "Segment #" << i << " found.\n";
     Intersector.Segment(i,S1,S2);
+    Sprintf(aBuff, "ires1_%d", i);
+    di << aBuff;
+    DrawTrSurf::Set(aBuff, S1);
     CD = new DrawTrSurf_Curve2d(S1, Draw_bleu, 30);
     dout << CD;
+
+    Sprintf(aBuff, "ires2_%d", i);
+    di << " " << aBuff << "\n";
+    DrawTrSurf::Set(aBuff, S2);
     CD = new DrawTrSurf_Curve2d(S2, Draw_violet, 30);
     dout << CD;
   }
diff --git a/src/IntImpParGen/IntImpParGen.cxx b/src/IntImpParGen/IntImpParGen.cxx
index 4e2d0af..9003996 100644
--- a/src/IntImpParGen/IntImpParGen.cxx
+++ b/src/IntImpParGen/IntImpParGen.cxx
@@ -60,18 +60,22 @@ void IntImpParGen::DeterminePosition(IntRes2d_Position& Pos1,
     }
   }
    
-  if(TheDomain.HasLastPoint()) {
-    if(Pnt1.Distance(TheDomain.LastPoint()) 
-       <= TheDomain.LastTolerance()) {
-      if(Pos1==IntRes2d_Head) {
-	if(Abs(Param1-TheDomain.LastParameter())
-	   < Abs(Param1-TheDomain.FirstParameter()))
-	  Pos1=IntRes2d_End; 	
+  if (TheDomain.HasLastPoint())
+  {
+    if (Pnt1.Distance(TheDomain.LastPoint())
+        <= TheDomain.LastTolerance())
+    {
+      if (Pos1 == IntRes2d_Head)
+      {
+        if (Abs(Param1 - TheDomain.LastParameter()) <
+                              Abs(Param1 - TheDomain.FirstParameter()))
+          Pos1 = IntRes2d_End;
       }
-      else {
-	Pos1=IntRes2d_End; 
+      else
+      {
+        Pos1 = IntRes2d_End;
       }
-    } 
+    }
   }
 }   
 //----------------------------------------------------------------------
diff --git a/src/IntTools/IntTools_Context.cxx b/src/IntTools/IntTools_Context.cxx
index 64ad3b1..75c8c49 100644
--- a/src/IntTools/IntTools_Context.cxx
+++ b/src/IntTools/IntTools_Context.cxx
@@ -260,11 +260,10 @@ BRepTopAdaptor_FClass2d& IntTools_Context::FClass2d(const TopoDS_Face& aF)
   //
   if (!myFClass2dMap.IsBound(aF)) {
     const TopoDS_Face aFF = TopoDS::Face(aF.Oriented(TopAbs_FORWARD));
-    const Standard_Real aTolF=BRep_Tool::Tolerance(aFF);
     //
     pFClass2d = (BRepTopAdaptor_FClass2d*)myAllocator->
                         Allocate(sizeof(BRepTopAdaptor_FClass2d));
-    new (pFClass2d)BRepTopAdaptor_FClass2d(aFF, aTolF);
+    new (pFClass2d)BRepTopAdaptor_FClass2d(aFF);
 
     myFClass2dMap.Bind(aFF, (Standard_Address)pFClass2d);
   }
diff --git a/src/IntTools/IntTools_Tools.cxx b/src/IntTools/IntTools_Tools.cxx
index 7c8a6d4..a7d8236 100644
--- a/src/IntTools/IntTools_Tools.cxx
+++ b/src/IntTools/IntTools_Tools.cxx
@@ -429,13 +429,12 @@ static
 //function : ClassifyPointByFace
 //purpose  : 
 //=======================================================================
-  TopAbs_State IntTools_Tools::ClassifyPointByFace(const TopoDS_Face& aF,
-                                                   const gp_Pnt2d& aP2d)
+TopAbs_State IntTools_Tools::ClassifyPointByFace(const TopoDS_Face& aF,
+                                                 const gp_Pnt2d& aP2d)
 {
-  const Standard_Real aTolF=BRep_Tool::Tolerance(aF);
-  BRepTopAdaptor_FClass2d aClass2d(aF, aTolF);
-  const TopAbs_State aState=aClass2d.Perform(aP2d);
-  
+  BRepTopAdaptor_FClass2d aClass2d(aF);
+  const TopAbs_State aState = aClass2d.Perform(aP2d);
+
   return aState;
 }
 
